import React from 'react';
declare type AssistedInstallerFeatureType = 'ASSISTED_INSTALLER_SNO_FEATURE' | 'ASSISTED_INSTALLER_OCS_FEATURE' | 'ASSISTED_INSTALLER_CNV_FEATURE' | 'ASSISTED_INSTALLER_NETWORK_TYPE_SELECTION_FEATURE' | 'ASSISTED_INSTALLER_PLATFORM_INTEGRATION_FEATURE';
export declare type FeatureListType = {
    [key in AssistedInstallerFeatureType]?: boolean;
};
export declare const ACM_ENABLED_FEATURES: FeatureListType;
export declare const SINGLE_CLUSTER_ENABLED_FEATURES: FeatureListType;
export declare const STANDALONE_DEPLOYMENT_ENABLED_FEATURES: FeatureListType;
export declare type FeatureGateContextType = {
    isFeatureEnabled: (feature: AssistedInstallerFeatureType) => boolean;
};
export declare const FeatureGateContext: React.Context<FeatureGateContextType>;
export declare const FeatureGateContextProvider: React.FC<{
    features: FeatureListType;
}>;
export declare const useFeature: (feature: AssistedInstallerFeatureType) => boolean;
export {};
